/**********************************************************************
Copyright 2012 Advanced Micro Devices, Inc. All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

	Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
	Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or
 other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
 OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
********************************************************************/

template <int TREE_SIZE>
struct AppleTree
{
	int apples[TREE_SIZE];
};

template <int TREE_NUM>
struct ApplesOnTrees
{
	int trees[TREE_NUM];
};


__kernel void AoSKernel(global AppleTree<num1> *trees, global int *outBuf,int treeSize)
{
   uint gid = get_global_id(0);
   uint res = 0;
   for(int i=0;i<treeSize;i++)
   {
       res += trees[gid].apples[i];
   }
   outBuf[gid] = res;
}


__kernel void SoAKernel(global ApplesOnTrees<num2> *applesOnTrees, global int *outBuf,int treeSize)
{
   uint gid = get_global_id(0);
   uint res = 0;
   for(int i = 0;i<treeSize;i++)
   {
	   res += applesOnTrees[i].trees[gid];
   }
   outBuf[gid] = res;
}
